package com.wissamfawaz;

import java.util.Arrays;
import java.util.PriorityQueue;

public class Main {

	public static void main(String[] args) {
		Point[] points = {
			new Point(0, 0),
			new Point(-1, 0),
			new Point(1, 0),
			new Point(0, 1),
			new Point(1, 1)
		};
		
		System.out.println("Before sorting: ");
		System.out.println(Arrays.toString(points));
		
		Point[] sortedPoints = pqSort(points);
 		
		System.out.println("After sorting");
		System.out.println(Arrays.toString(sortedPoints));	
	}
	
	private static Point[] pqSort(Point[] points) {
		Point[] sortedPoints = new Point[points.length];
		
		PriorityQueue<Point> pq = new PriorityQueue<>(new PointsComparator());
		
		// 1. Insertion step
		for(Point point : points) {
			pq.add(point); // pq.offer
		}
		
		// 2. Removal step
		int idx = 0;
		
		while(!pq.isEmpty()) {
			sortedPoints[idx++] = pq.remove(); // pq.poll
		}		
		
		return sortedPoints;
	}

}
